// ConOptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DesktopReciever.h"
#include "ConOptionsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConOptionsDlg dialog


CConOptionsDlg::CConOptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConOptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConOptionsDlg)
	m_strServer = _T("loopback");
	m_iPort = 1000;
	//}}AFX_DATA_INIT
}


void CConOptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConOptionsDlg)
	DDX_Text(pDX, IDC_ESERVER, m_strServer);
	DDX_Text(pDX, IDC_EPORT, m_iPort);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConOptionsDlg, CDialog)
	//{{AFX_MSG_MAP(CConOptionsDlg)
	ON_BN_CLICKED(IDC_BCONBUTTON, OnBConButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConOptionsDlg message handlers



void CConOptionsDlg::SetReciever(CDesktopRecieverSocket *pReciever)
{
	m_pReciever=pReciever;
}

void CConOptionsDlg::OnBConButton() 
{
	switch(m_iStatus)
	{
	case STATUS_NOTCONNECTED:
		GetDlgItem(IDOK)->EnableWindow(FALSE);
		GetDlgItem(IDCANCEL)->EnableWindow(FALSE);
		GetDlgItem(IDC_BCONBUTTON)->SetWindowText("&Stop");

		UpdateData();
		m_iStatus=STATUS_TRYCONNECTING;
		m_pReciever->Create();
		m_pReciever->Connect(m_strServer,m_iPort);
		break;
	case STATUS_TRYCONNECTING:
		GetDlgItem(IDOK)->EnableWindow(TRUE);
		GetDlgItem(IDCANCEL)->EnableWindow(TRUE);
		GetDlgItem(IDC_BCONBUTTON)->SetWindowText("&Connect");

		m_iStatus=STATUS_NOTCONNECTED;
		m_pReciever->Close();
		break;
	}
}

void CConOptionsDlg::SetStatus(int iStatus)
{
	m_iStatus=iStatus;
}

BOOL CConOptionsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_pReciever->SetParent(this);
	if(m_iStatus==STATUS_CONNECTED)
	{
		GetDlgItem(IDC_BCONBUTTON)->EnableWindow(FALSE);
		GetDlgItem(IDOK)->EnableWindow(FALSE);
		GetDlgItem(IDC_EPORT)->EnableWindow(FALSE);
		GetDlgItem(IDC_ESERVER)->EnableWindow(FALSE);
	}	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConOptionsDlg::OnConnect()
{
	m_iStatus=STATUS_CONNECTED;
	CDialog::OnOK();
}

int CConOptionsDlg::GetStatus()
{
	return m_iStatus;
}

CString CConOptionsDlg::GetServerName()
{
	return m_strServer;
}

void CConOptionsDlg::SetServer(CString strServer)
{
	m_strServer=strServer;
}

void CConOptionsDlg::SetPort(int iPort)
{
	m_iPort=iPort;
}

int CConOptionsDlg::GetPort()
{
	return m_iPort;
}
