// DesktopRecieverDoc.cpp : implementation of the CDesktopRecieverDoc class
//

#include "stdafx.h"
#include "DesktopReciever.h"

#include "DesktopRecieverDoc.h"
#include "ConOptionsDlg.h"
#include "DesktopRecieverView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDesktopRecieverDoc

IMPLEMENT_DYNCREATE(CDesktopRecieverDoc, CDocument)

BEGIN_MESSAGE_MAP(CDesktopRecieverDoc, CDocument)
	//{{AFX_MSG_MAP(CDesktopRecieverDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDesktopRecieverDoc construction/destruction

CDesktopRecieverDoc::CDesktopRecieverDoc()
{
	// TODO: add one-time construction code here
	m_iStatus=STATUS_NOTCONNECTED;
	m_iPort=1000;
	m_strServer="loopback";
	m_sReciever.SetDocument(this);
	m_bitmap.bmBits=NULL;
}

CDesktopRecieverDoc::~CDesktopRecieverDoc()
{
}

BOOL CDesktopRecieverDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	POSITION pos=GetFirstViewPosition();
	CView* pView=GetNextView(pos);
	if(pView)
	{
	CConOptionsDlg dlgOptions;
	dlgOptions.SetStatus(m_iStatus);
	dlgOptions.SetServer(m_strServer);
	dlgOptions.SetPort(m_iPort);
	dlgOptions.SetReciever(&m_sReciever);
	if(m_iStatus!=STATUS_CONNECTED)
		SetTitle("Not Connected");
	else
		{
			char sPort[10];
			itoa(m_iPort,sPort,10);
			SetTitle("Connected to "+m_strServer+" on port "+sPort);		
		}

	if(dlgOptions.DoModal()==IDOK)
	{
		m_strServer=dlgOptions.GetServerName();
		m_iPort=dlgOptions.GetPort();
		if((m_iStatus=dlgOptions.GetStatus())==STATUS_CONNECTED)
		{
			char sPort[10];
			itoa(m_iPort,sPort,10);
			SetTitle("Connected to "+m_strServer+" on port "+sPort);
			m_iStatus=dlgOptions.GetStatus();
		}
	}
	}
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CDesktopRecieverDoc serialization

void CDesktopRecieverDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDesktopRecieverDoc diagnostics

#ifdef _DEBUG
void CDesktopRecieverDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDesktopRecieverDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDesktopRecieverDoc commands



void CDesktopRecieverDoc::OnRecieve()
{
	static long step=0;

	CBitmap *Bitmap=new CBitmap;	
	static char* pHome;

	step++;
	switch(step-1)
	{
	case 0:
		m_sReciever.Receive(&m_bitmap.bmType,sizeof(LONG));
		break;
	case 1:
		m_sReciever.Receive(&m_bitmap.bmWidth,sizeof(LONG));
		break;
	case 2:
		m_sReciever.Receive(&m_bitmap.bmHeight,sizeof(LONG));
		break;
	case 3:
		m_sReciever.Receive(&m_bitmap.bmWidthBytes,sizeof(LONG));
		break;
	case 4:
		m_sReciever.Receive(&m_bitmap.bmPlanes,sizeof(WORD));
		break;
	case 5:
		m_sReciever.Receive(&m_bitmap.bmBitsPixel,sizeof(WORD));
		break;
	case 6:
		if(m_bitmap.bmBits)
			delete []m_bitmap.bmBits;
		m_bitmap.bmBits=new char[m_bitmap.bmWidthBytes*m_bitmap.bmHeight];
		pChar=(char*)m_bitmap.bmBits;
		pHome=pChar;
		m_sReciever.Receive(pChar,m_bitmap.bmWidthBytes);
		pChar=pChar+m_bitmap.bmWidthBytes;
		break;
	default:
		if((step-6)<m_bitmap.bmHeight)
		{
			m_sReciever.Receive(pChar,m_bitmap.bmWidthBytes);
			pChar=pChar+m_bitmap.bmWidthBytes;
		}
		else
		{
			POSITION pos=GetFirstViewPosition();
			CDesktopRecieverView* pView=(CDesktopRecieverView*)GetNextView(pos);

			m_sReciever.Receive(pChar,m_bitmap.bmWidthBytes);
			pChar=pChar+m_bitmap.bmWidthBytes;

			Bitmap->CreateBitmapIndirect(&m_bitmap);
			delete []pHome;
			pView->SetBitmap(Bitmap);
			pView->Invalidate();
			step=0;
		}
	}
}

void CDesktopRecieverDoc::OnClose()
{
	POSITION pos=GetFirstViewPosition();
	CDesktopRecieverView* pView=(CDesktopRecieverView*)GetNextView(pos);	
	pView->MessageBox("Server has been disconnected.","Connection Canceled",MB_OK|MB_ICONINFORMATION);
	m_iStatus=STATUS_NOTCONNECTED;
	SetTitle("Not Connected");
}




