// DesktopSenderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DesktopSender.h"
#include "DesktopSenderDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define STATUS_NOTSTARTED 0
#define STATUS_STARTED 1
#define STATUS_CONNECTED 2

#define WM_TRAYMSG WM_USER+0

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDesktopSenderDlg dialog

CDesktopSenderDlg::CDesktopSenderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDesktopSenderDlg::IDD, pParent) , m_trayIcon(IDR_TRAYMENU)
{
	//{{AFX_DATA_INIT(CDesktopSenderDlg)
	m_iPort = 1000;
	m_iInterval = 1000;
	m_fRatio = 100.0f;
	m_bMinWhenCon = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_iStatus=STATUS_NOTSTARTED;
}

void CDesktopSenderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDesktopSenderDlg)
	DDX_Control(pDX, IDC_BAPPLY, m_ctlApply);
	DDX_Control(pDX, IDC_BCOMMUNICATE, m_ctlComButton);
	DDX_Text(pDX, IDC_EPORT, m_iPort);
	DDX_Text(pDX, IDC_EINTERVAL, m_iInterval);
	DDX_Text(pDX, IDC_EZRATIO, m_fRatio);
	DDX_Check(pDX, IDC_CMINIMIZE, m_bMinWhenCon);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDesktopSenderDlg, CDialog)
	//{{AFX_MSG_MAP(CDesktopSenderDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BCOMMUNICATE, OnComCommand)
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_COMMAND(ID_TRAY_OPEN, OnTrayOpen)
	ON_EN_CHANGE(IDC_EZRATIO, OnChangeEzratio)
	ON_EN_CHANGE(IDC_EINTERVAL, OnChangeEinterval)
	ON_BN_CLICKED(IDC_BAPPLY, OnBapply)
	ON_WM_DESTROY()
	ON_COMMAND(ID_TRAY_ABOUT, OnTrayAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDesktopSenderDlg message handlers

BOOL CDesktopSenderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_trayIcon.SetNotificationWnd(this,WM_TRAYMSG);
	m_trayIcon.SetIcon(MAKEINTRESOURCE(IDR_MAINFRAME),"Desktop Sender");
	m_sSender.SetParent(this);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDesktopSenderDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDesktopSenderDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDesktopSenderDlg::OnComCommand() 
{
	switch(m_iStatus)
	{
	case STATUS_NOTSTARTED:

		//update controls:
		GetDlgItem(IDC_EPORT)->EnableWindow(FALSE);
		m_ctlComButton.SetWindowText("&Stop Listening For Incomming Calls.");
		m_ctlApply.ShowWindow(SW_HIDE);

		//start listening:
		UpdateData();
		m_sSender.Create(m_iPort);
		m_sSender.Listen();		

		m_iStatus=STATUS_STARTED;

		break;

	case STATUS_STARTED:

		//update controls:
		GetDlgItem(IDC_EPORT)->EnableWindow(TRUE);
		m_ctlComButton.SetWindowText("&Start Listening For Incomming Calls.");

		//stop listening:
		m_sSender.Close();

		m_iStatus=STATUS_NOTSTARTED;
		break;
	
	case STATUS_CONNECTED:
		//update controls:
		GetDlgItem(IDC_EPORT)->EnableWindow(FALSE);
		m_ctlComButton.SetWindowText("&Start Listening For Incomming Calls.");
		m_ctlApply.ShowWindow(SW_HIDE);
		GetDlgItem(IDC_CMINIMIZE)->ShowWindow(SW_SHOW);

		//stop sending:
		m_sReceiver.Close();
		m_sSender.Close();

    	m_iStatus=STATUS_NOTSTARTED;
		break;
	}
}

extern CDesktopSenderApp theApp;

void CDesktopSenderDlg::OnAccept()
{
	m_sSender.Accept(m_sReceiver);
	m_iStatus=STATUS_CONNECTED;	
	SetWindowText("Connected - Desktop Sender");
	m_ctlComButton.SetWindowText("&Cancel Connection.");	
	GetDlgItem(IDC_CMINIMIZE)->ShowWindow(SW_HIDE);
	m_ctlApply.ShowWindow(SW_SHOW);

	UpdateData();
	if(m_bMinWhenCon)
		theApp.HideApplication();
	SetTimer(IDT_TIMER,m_iInterval,NULL);
}

void CDesktopSenderDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent==IDT_TIMER)
	{
	CDC* pDC=GetDesktopWindow()->GetWindowDC();
	if(pDC)
	{
		BITMAP bm;
		CBitmap Bitmap;
		if(m_fRatio>100.0)
		{
			m_fRatio=100.0;
			UpdateData(FALSE);
		}

		Bitmap.CreateCompatibleBitmap(pDC,int(GetSystemMetrics(SM_CXSCREEN)*m_fRatio/100),int(GetSystemMetrics(SM_CYSCREEN)*m_fRatio/100));
		CDC dcMem;
		dcMem.CreateCompatibleDC(pDC);
		dcMem.SelectObject(&Bitmap);
		dcMem.StretchBlt(0,0,int(GetSystemMetrics(SM_CXSCREEN)*m_fRatio/100),int(GetSystemMetrics(SM_CYSCREEN)*m_fRatio/100),pDC,0,0,GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN),SRCCOPY);
		Bitmap.GetBitmap(&bm);
		m_sReceiver.Send(&bm.bmType,sizeof(LONG));
		m_sReceiver.Send(&bm.bmWidth,sizeof(LONG));
		m_sReceiver.Send(&bm.bmHeight,sizeof(LONG));
		m_sReceiver.Send(&bm.bmWidthBytes,sizeof(LONG));
		m_sReceiver.Send(&bm.bmPlanes,sizeof(WORD));
		m_sReceiver.Send(&bm.bmBitsPixel,sizeof(WORD));
		char* pBits=new char[bm.bmWidthBytes*bm.bmHeight];
		char* pHome=pBits;
		Bitmap.GetBitmapBits(bm.bmWidthBytes*bm.bmHeight,pBits);
		for(int i=0;i<bm.bmHeight;i++)
		{
			m_sReceiver.Send(pBits,bm.bmWidthBytes);
			pBits=pBits+bm.bmWidthBytes;
		}		
		delete []pHome;
	}
	}
	CDialog::OnTimer(nIDEvent);
}

void CDesktopSenderDlg::OnSize(UINT nType, int cx, int cy) 
{
	if(nType==SIZE_MINIMIZED)
		theApp.HideApplication();
	else
		CDialog::OnSize(nType, cx, cy);
}

void CDesktopSenderDlg::OnTrayOpen() 
{
	ShowWindow(SW_NORMAL);
}

void CDesktopSenderDlg::OnChangeEzratio() 
{
	if(m_ctlApply.IsWindowVisible())
		m_ctlApply.EnableWindow();
}

void CDesktopSenderDlg::OnChangeEinterval() 
{
	if(m_ctlApply.IsWindowVisible())
		m_ctlApply.EnableWindow();
}

void CDesktopSenderDlg::OnBapply() 
{
	UpdateData();
	if(m_fRatio>100.0)
	{
		m_fRatio=100.0;
		UpdateData(FALSE);
	}
	KillTimer(IDT_TIMER);
	SetTimer(IDT_TIMER,m_iInterval,NULL);
	m_ctlApply.EnableWindow(FALSE);
}

void CDesktopSenderDlg::OnDestroy() 
{
	if(m_iStatus==STATUS_CONNECTED)
	{
		m_sSender.Close();
		m_sReceiver.Close();	
		KillTimer(IDT_TIMER);
	}
	if(m_iStatus==STATUS_STARTED)
	{
		m_sSender.Close();
	}
	CDialog::OnDestroy();	
}

void CDesktopSenderDlg::OnTrayAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}


